/* com/syncbuilder/device/UserInfo.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: UserInfo.java,v 1.1 1998/09/16 08:57:34 christ Exp $ */

package com.syncbuilder.device;

/**
* Information about the PalmPilot's user and about the last HotSync attempt.
*
* @author Kenneth Albanowski, changes by Tilo Christ
*/
public class UserInfo 
{
	public String toString() 
	{
		return "<com.syncbuilder.device.UserInfo userID "+userID+", viewerID "+viewerID+", lastSyncPC "+lastSyncPC+
			", successfulSyncDate "+((successfulSyncDate == null) ? "null" : successfulSyncDate.toString())+", syncLast "+((lastSyncDate == null) ? "null" : lastSyncDate.toString())+
			", username '"+username+"', password '" + com.syncbuilder.util.Util.hexPrint(password) +"'>";
	}

	/** A unique ID which is being assigned to the user at the very first HotSync */
	public int userID;
	/** Unknown meaning */
	public int viewerID;
	/** The unique ID of the PC with which the last HotSync took place */
	public int lastSyncPC;
	/** The date of the last successful HotSync */
	public java.util.Date successfulSyncDate;
	/** Unknown meaning, seems to be null all the time */
	public java.util.Date lastSyncDate;
	/** The name of the PalmPilot's user */
	public String username;
	/** The user's password in encrypted form */
	public byte[] password;
}
