/* com/syncbuilder/internal/core/calls.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: calls.java,v 1.2 1998/12/09 09:54:43 christ Exp $ */

package com.syncbuilder.internal.core;

import java.io.*;
import com.syncbuilder.storage.*;
import com.syncbuilder.device.*;
import com.syncbuilder.sync.DlpException;

/**
* This class acts as the connecting element between the Java-binding and the native code.
* One fine day it will hopefully be obsolete :-)
*
* @author Kenneth Albanowski, method removals by Tilo Christ
*/
public class calls 
{
	// ================== Sockets ============================================================
	public static  native int pi_close(int socket) throws IOException;
	public static  native int pi_socket(int domain, int type, int protocol) throws IOException;
	public static  native int pi_bind(int socket, String device) throws IOException;
	public static  native int pi_listen(int socket, int backlog) throws IOException;
	public static  native int pi_accept(int socket) throws IOException;
	public static  native int pi_version(int socket) throws IOException;
	public static  native int pi_tickle(int socket) throws IOException;
	public static  native int pi_watchdog(int socket, int interval) throws IOException;
	public static  native int pi_read(int socket, byte[] data, int len) throws IOException;
	public static  native int pi_write(int socket, byte[] data, int len) throws IOException;
	public static  native int pi_noendsync(int socket);

	public static  native int dlp_DeleteDB(int socket, int card, String name) throws DlpException;
	public static  native int dlp_DeleteCategory(int socket, int handle, int category) throws DlpException;

	public static  native java.util.Date dlp_GetSysDateTime(int socket) throws DlpException;
	public static  native int dlp_SetSysDateTime(int socket, java.util.Date date) throws DlpException;
	public static  native AppBlock dlp_ReadAppBlock(int socket, int handle, DatabaseImpl dbClass) throws DlpException;
	public static  native SortBlock dlp_ReadSortBlock(int socket, int handle, DatabaseImpl dbClass) throws DlpException;
	public static  native Pref dlp_ReadAppPreference(int socket, Char4 creator, int id, boolean backup, DatabaseImpl dbClass) throws DlpException;
	public static  native Record dlp_ReadNextModifiedRec(int socket, int handle, DatabaseImpl dbClass) throws DlpException;
	public static  native Record dlp_ReadNextModifiedRecInCategory(int socket, int handle, int category, DatabaseImpl dbClass) throws DlpException;
	public static  native Record dlp_ReadNextRecInCategory(int socket, int handle, int category, DatabaseImpl dbClass) throws DlpException;
	public static  native Record dlp_ReadRecordByID(int socket, int handle, RecordID id, DatabaseImpl dbClass) throws DlpException;
	public static  native Resource dlp_ReadResourceByType(int socket, int handle, Char4 type, int id, DatabaseImpl dbClass) throws DlpException;
	public static  native Resource dlp_ReadResourceByIndex(int socket, int handle, int index, DatabaseImpl dbClass) throws DlpException;
	public static  native int dlp_WriteAppPreference(int socket, Pref pref) throws DlpException;
	public static  native int dlp_WriteResource(int socket, int handle, Resource resource) throws DlpException;
	public static  native int dlp_WriteAppBlock(int socket, int handle, AppBlock appblock) throws DlpException;
	public static  native int dlp_WriteSortBlock(int socket, int handle, SortBlock sortblock) throws DlpException;
	public static  native CardInfo dlp_ReadStorageInfo(int socket, int card) throws DlpException;
	public static  native int dlp_ResetSystem(int socket) throws DlpException;
	public static  native int dlp_WriteUserInfo(int socket, UserInfo info) throws DlpException;
	public static  native SysInfo dlp_ReadSysInfo(int socket) throws DlpException;
	public static  native NetSyncInfo dlp_ReadNetSyncInfo(int socket) throws DlpException;
	public static  native int dlp_WriteNetSyncInfo(int socket, NetSyncInfo info) throws DlpException;
	public static  native int dlp_CleanUpDatabase(int socket, int handle) throws DlpException;
	public static  native int dlp_ResetSyncFlags(int socket, int handle) throws DlpException;
	public static  native int dlp_MoveCategory(int socket, int handle, int from, int to) throws DlpException;
	public static  native int dlp_DeleteRecord(int socket, int handle, boolean all, RecordID id) throws DlpException;
	public static  native int dlp_DeleteResource(int socket, int handle, boolean all, Char4 type, int id) throws DlpException;
	public static  native int dlp_ReadFeature(int socket, Char4 creator, int id) throws DlpException;
	public static  native RecordID[] dlp_ReadRecordIDList(int socket, int handle, boolean sort, int start, int max) throws DlpException;
	public static  native byte[] dlp_CallApplication(int socket, Char4 creator, int type, int action, byte[] argument, int[] retcode) throws DlpException;
	public static  native int dlp_ResetDBIndex(int socket, int handle) throws DlpException;
	
	public static  byte[] getByteArray(int length) { return new byte[length]; }
	public static  int getArrayLength(byte[] array) { return array.length; }
	public static  RecordID[] makeRecordIDArray(int length) { return new RecordID[length]; }
	public static  Object[] makeStringArray(int length) { return new String[length]; }
	public static  int[] makeIntArray(int length) { return new int[length]; }
	
	static 
	{
		System.loadLibrary("JavaPisock");
	}
}

