/* com/syncbuilder/service/ServiceMessage.java:
*
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: ServiceMessage.java,v 1.2 1998/10/25 14:08:36 christ Exp $ */

package com.syncbuilder.service;

/**
* A message from a service.
* Contains message-text as well as a level of severity.
*
* @author Tilo Christ
*/
public class
ServiceMessage
{
	/**
	* Construct a ServiceMessage with the specified message-text and a NORMAL level
	* of severity.
	*/
	public ServiceMessage(String msg)
	{
		this._msg = msg;
		this._level = LVL_NORMAL;
	}

	/**
	* Construct a ServiceMessage with the specified message-text and the specified level
	* of severity (use the LVL_* constants).
	*/
	public ServiceMessage(String msg, int level)
	{
		this._msg = msg;
		this._level = level;
	}

	public String getMessageText()
	{
		return (_msg != null) ? _msg : "(empty)";
	}
	
	public int getLevel()
	{
		return _level;
	}

	public String getLevelName()
	{
		return _level_names[_level];
	}

	public String toString()
	{
		return "<com.syncbuilder.service.ServiceMessage: level = " + getLevelName() + " message = '"+ getMessageText() +"'>";
	}

	// The constants for the level of severity

	public final static int LVL_DEBUG   = 0;
	public final static int LVL_NORMAL  = 1;
	public final static int LVL_WARNING = 2;
	public final static int LVL_FAILURE = 3;

	private final static String[] _level_names = {"DEBUG", "NORMAL", "WARNING", "FAILURE"};

	private final String _msg;
	private final int _level;
}
