/* com/syncbuilder/storage/DatabaseImpl.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: DatabaseImpl.java,v 1.2 1998/12/09 09:59:36 christ Exp $ */

package com.syncbuilder.storage;

/**
* DatabaseImpl is a helper class for Database.
* It implements all the operations which are application-specific. It is subclassed
* by several application-specific implementations.
*
* @see Database
* @author Kenneth Albanowski, massive changes by Tilo Christ
*/
abstract public class DatabaseImpl
{
	abstract public Record createRecord();

	public Record createRecord(RecordID id)
	{ 
		return createRecord(null, id, 0, 0, 0); 
	}

	abstract public Record createRecord(byte[] contents, RecordID id, int index, int attr, int cat);
		
	public Resource createResource()
	{
		return null;
	}
	
	public Resource createResource(Char4 type, int id) 
	{ 
		return createResource(null, type, id, 0); 
	}
				
	public Resource createResource(byte[] contents, Char4 type, int id, int index)
	{
		return null;
	}
	
	public Pref createPref(byte[] contents, int id, int version, boolean backup)
		throws NoCreatorException
	{
		return null;
	}
		
	public AppBlock createAppBlock()
	{
		return null;
	}
	 
	public SortBlock createSortBlock()
	{
		return null;
	}
	
	public AppBlock createAppBlock(byte[] contents)
	{
		return null;
	}
	
	public SortBlock createSortBlock(byte[] contents)
	{
		return null;
	}

	/**
	* Get the creator ID of the database. 
	* The creator ID is a unique four-letter ID which is used to link a database
	* to the application which created it.
	*/
    abstract public Char4 getCreatorID();
		
	/**
	* Get the name of the database.
	* The name can have up to 31 characters.
	*/
    abstract public String getDBName();
}
