/* com/syncbuilder/storage/RecordID.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: RecordID.java,v 1.1 1998/09/16 08:57:38 christ Exp $ */

package com.syncbuilder.storage;


/**
* A representation of the (hopefully) unique ID of a database-record.
*
* @author Kenneth Albanowski, changes by Tilo Christ
*/
public class RecordID 
	implements java.io.Serializable
{
	public RecordID(int id) 
	{
		this.setValue(id);
	}

	public RecordID() 
	{
		this.setValue(0);
	}
	
	public void setValue(int id) 
	{
		value = id;
	}
	
	public int getValue() 
	{
		return value;
	}
	
	public boolean equals(Object other) 
	{
		if (other==null || !(other instanceof com.syncbuilder.storage.RecordID))
			return false;
			
		return (value == ((RecordID)other).getValue());
	}
	
	public String toString() 
	{
		return "<RecordID "+value+">";
	}

	private int value;
}
