/* com/syncbuilder/storage/Resource.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: Resource.java,v 1.1 1998/09/16 08:57:38 christ Exp $ */

package com.syncbuilder.storage;


/** 
 * The base-class for representations of a resource, as contained in a resource-database.
 * A resource-database is typically created on the host and then
 * transferred to the PalmPilot. Its contents typically remain unchanged.
 * The resources can be addressed through a resource-ID.
 *
 * @see com.syncbuilder.storage.Record
 * @author Kenneth Albanowski, changes by Tilo Christ
 */
abstract public class Resource 
	extends Block 
{
	public Resource() 
	{
		super();
	}

	public Resource(byte[] contents, Char4 type, int id, int index) 
	{
		this.id = id;
		this.index = index;
		this.type = type;

		this.unpack(contents);
	}

	public String toString() 
	{
		return "<Resource, type "+type+", id "+id+", index "+index+
			", raw '"+ com.syncbuilder.util.Util.prettyPrint(raw)+"'>";
	}

	public int id;
	public int index;
	public Char4 type;
}

