/* com/syncbuilder/storage/appointment/AppBlock.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: AppBlock.java,v 1.1 1998/09/16 08:57:39 christ Exp $ */

package com.syncbuilder.storage.appointment;

import java.io.*;

/**
* The AppBlock of the PalmPilot's Datebook-application.
*
* @author Kenneth Albanowski, changes by Tilo Christ 
*/
public class AppBlock 
	extends com.syncbuilder.storage.CategoryAppBlock 
{
	public AppBlock() 
	{
		super();
	}
		
	public AppBlock(byte[] contents) 
	{
		super(contents);
	}
	
	public void unpack(byte[] data)
		throws java.lang.IllegalArgumentException
	{
		if (data.length < com.syncbuilder.storage.CategoryAppBlock.LENGTH + 2)
			throw new java.lang.IllegalArgumentException("data-array too short!");

		super.unpack(data);
		
		startOfWeek = data[com.syncbuilder.storage.CategoryAppBlock.LENGTH] & 0xff;		
	}
	
	public byte[] pack()
	{
		byte[] buf = new byte[com.syncbuilder.storage.CategoryAppBlock.LENGTH + 2];
		super.packCategories(buf);
		
		buf[com.syncbuilder.storage.CategoryAppBlock.LENGTH]     = (byte)startOfWeek;
		buf[com.syncbuilder.storage.CategoryAppBlock.LENGTH + 1] = (byte)0; // gap-fill
		
		return buf;
	}
	
	public void fill() 
	{
		super.fill();
		startOfWeek = 0;
	}

	public boolean equals(Object other)
	{
		if (!(other instanceof com.syncbuilder.storage.appointment.AppBlock))
			return false;
			
		com.syncbuilder.storage.appointment.AppBlock other2 = (com.syncbuilder.storage.appointment.AppBlock)other;
		
		if (!super.equals(other2))
			return false;
			
		if (startOfWeek != other2.startOfWeek)
			return false;
			
		return true;
	}			

		
	public String describe() 
	{
		return "startOfWeek="+ startOfWeek +", " + super.describe();
	}

	public int startOfWeek;
}
