/* com/syncbuilder/storage/appointment/DatabaseImpl.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: DatabaseImpl.java,v 1.1 1998/09/16 08:57:39 christ Exp $ */

package com.syncbuilder.storage.appointment;


/**
* The DatabaseImpl for use with the Pilot's built-in Datebook-application
*
* @author Kenneth Albanowski, changes by Tilo Christ 
*/
public class DatabaseImpl 
	extends com.syncbuilder.storage.DatabaseImpl 
{
	public com.syncbuilder.storage.Record createRecord() 
		{ return new com.syncbuilder.storage.appointment.Record(); }
		
	public com.syncbuilder.storage.Record createRecord(byte[] contents, com.syncbuilder.storage.RecordID id, int index, int attr, int cat) 
		{ return new com.syncbuilder.storage.appointment.Record(contents, id, index, attr, cat); }

	public com.syncbuilder.storage.AppBlock createAppBlock() 
		{ return new com.syncbuilder.storage.appointment.AppBlock(); }
		
	public com.syncbuilder.storage.AppBlock createAppBlock(byte[] contents) 
		{ return new com.syncbuilder.storage.appointment.AppBlock(contents); }
	
	public com.syncbuilder.storage.Char4 getCreatorID() 
	{ 
		return _CREATOR_ID; 
	}
		
	public String getDBName() 
		{ return "DatebookDB"; }

	
	private final static com.syncbuilder.storage.Char4 _CREATOR_ID = new com.syncbuilder.storage.Char4("date");
}
