/* com/syncbuilder/storage/appointment/repeat.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: repeat.java,v 1.1 1998/09/16 08:57:39 christ Exp $ */

package com.syncbuilder.storage.appointment;

/**
* Type-safe representation of various repeat-types
*
* @author Kenneth Albanowski, changes by Tilo Christ
*/
public class repeat 
	implements java.io.Serializable
{
	public static repeat get(int value) 
	{
		return objs[value];
	}
	
	public static repeat get(String value) 
	{
		for(int i=0;i<names.length;i++)
			if (names[i].equals(value))
				return objs[i];

		return null;
	}

	public static String[] getNames() 
	{
		return names;
	}
	
	public String toString() 
	{
		return "repeat."+names[idx];
	}
		
	public int getValue() 
	{
		return idx;
	}
	
	public String getName() 
	{
		return names[idx];
	}

	public final static repeat None = new repeat(0);
	public final static repeat Daily = new repeat(1);
	public final static repeat Weekly = new repeat(2);
	public final static repeat MonthlyByDay = new repeat(3);
	public final static repeat MonthlyByDate = new repeat(4);
	public final static repeat Yearly = new repeat(5);


	private repeat(int value) 
	{
		this.idx = value;
	}
	
	private int idx;
	
	final static private String[] names = 
		{ "None", "Daily", "Weekly", "MonthlyByDay", "MonthlyByDate", "Yearly" };

	private static repeat[] objs;
	

	static {
		objs = new repeat[6];
		objs[0] = repeat.None;
		objs[1] = repeat.Daily;
		objs[2] = repeat.Weekly;
		objs[3] = repeat.MonthlyByDay;
		objs[4] = repeat.MonthlyByDate;
		objs[5] = repeat.Yearly;
	}
};
