/* com/syncbuilder/storage/appointment/time.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: time.java,v 1.1 1998/09/16 08:57:39 christ Exp $ */

package com.syncbuilder.storage.appointment;

/**
* Type-safe constants to express units of time
*
* @author Kenneth Albanowski, changes by Tilo Christ
*/
public class time 
	implements java.io.Serializable
{
	public static time get(int value) 
	{
		return objs[value];
	}
	
	public static time get(String value) 
	{
		for(int i=0;i<names.length;i++)
			if (names[i].equals(value))
				return objs[i];

		return null;
	}
	
	public static String[] getNames() 
	{
		return names;
	}
	
	public String toString() 
	{
		return "time."+names[idx];
	}
		
	public int getValue() 
	{
		return idx;
	}
	
	public String getName() 
	{
		return names[idx];
	}

	public boolean equals(Object other)
	{
		if (other==null)
			return false;
			
		if (!(other instanceof com.syncbuilder.storage.appointment.time))
			return false;
			
		return (idx == ((com.syncbuilder.storage.appointment.time)other).getValue());
	}

	public final static time Minutes = new time(0);
	public final static time Hours =  new time(1);
	public final static time Days = new time(2);
	

	private time(int value) {
		this.idx = value;
	}
	
	private static time[] objs;
	
	private int idx;
	
	final static private String[] names = 
		{ "Minutes", "Hours", "Days" };

	static 
	{
		objs = new time[3];
		objs[0] = time.Minutes;
		objs[1] = time.Hours;
		objs[2] = time.Days;
	}
};
