/* com/syncbuilder/storage/expense/DatabaseImpl.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: DatabaseImpl.java,v 1.2 1998/12/09 09:59:43 christ Exp $ */

package com.syncbuilder.storage.expense;

/**
* The DatabaseImpl for use with the Pilot's built-in Expense-application
*
* @author Kenneth Albanowski, changes by Tilo Christ 
*/
public class DatabaseImpl
	extends com.syncbuilder.storage.DatabaseImpl
{
	public com.syncbuilder.storage.AppBlock createAppBlock() 
		{ return new com.syncbuilder.storage.expense.AppBlock(); }
		
	public com.syncbuilder.storage.AppBlock createAppBlock(byte[] contents) 
		{ return new com.syncbuilder.storage.expense.AppBlock(contents); }
	
	public com.syncbuilder.storage.Record createRecord() 
		{ return new com.syncbuilder.storage.expense.Record(); }
		
	public com.syncbuilder.storage.Record createRecord(byte[] contents, com.syncbuilder.storage.RecordID id, int index, int attr, int cat) 
		{ return new com.syncbuilder.storage.expense.Record(contents, id, index, attr, cat); }

	public com.syncbuilder.storage.Pref createPref() 
		{ return new com.syncbuilder.storage.expense.Pref(); }

	public com.syncbuilder.storage.Pref createPref(byte[] contents, int id, int version, boolean backup)
	{ 
		if (id == 1) 
			return new com.syncbuilder.storage.expense.Pref(contents, id, version, backup);
		else
			return null;
	}
	
	public com.syncbuilder.storage.Char4 getCreatorID() 
		{ return _CREATOR_ID; }
		
	public String getDBName() 
		{ return "ExpenseDB"; }
	
	private final static com.syncbuilder.storage.Char4 _CREATOR_ID = new com.syncbuilder.storage.Char4("exps");
}
