/* com/syncbuilder/storage/mail/DatabaseImpl.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: DatabaseImpl.java,v 1.1 1998/09/16 08:57:41 christ Exp $ */

package com.syncbuilder.storage.mail;

/**
* The DatabaseImpl for use with the Pilot's built-in E-Mail-application
*
* @author Kenneth Albanowski, changes by Tilo Christ 
*/
public class DatabaseImpl
	extends com.syncbuilder.storage.DatabaseImpl
{
	public com.syncbuilder.storage.AppBlock createAppBlock() 
		{ return new com.syncbuilder.storage.mail.AppBlock(); }
		
	public com.syncbuilder.storage.AppBlock createAppBlock(byte[] contents) 
		{ return new com.syncbuilder.storage.mail.AppBlock(contents); }
	
	public com.syncbuilder.storage.Record createRecord() 
		{ return new com.syncbuilder.storage.mail.Record(); }
		
	public com.syncbuilder.storage.Record createRecord(byte[] contents, com.syncbuilder.storage.RecordID id, int index, int attr, int cat) 
		{ return new com.syncbuilder.storage.mail.Record(contents, id, index, attr, cat); }

	public com.syncbuilder.storage.Pref createPref(byte[] contents, com.syncbuilder.storage.Char4 creator, int id, int version, boolean backup)
	{ 
		if ((id == 1) || (id == 2)) 
			return new com.syncbuilder.storage.mail.SyncPref(contents, creator, id, version, backup);
		else if (id == 3)
			return new com.syncbuilder.storage.mail.SignaturePref(contents, creator, id, version, backup);
		else
			return null;
	}
	
	public com.syncbuilder.storage.Pref createSyncPref() 
		{ return new com.syncbuilder.storage.mail.SyncPref(); }
		
	public com.syncbuilder.storage.Pref createSyncPref(boolean local ) 
		{ return new com.syncbuilder.storage.mail.SyncPref(local); }
		
	public com.syncbuilder.storage.Pref createSignaturePref() 
		{ return new com.syncbuilder.storage.mail.SignaturePref(); }
		
	public com.syncbuilder.storage.Char4 getCreatorID() 
		{ return _CREATOR_ID; }
		
	public String getDBName() 
		{ return "MailDB"; }

	
	private final static com.syncbuilder.storage.Char4 _CREATOR_ID = new com.syncbuilder.storage.Char4("mail");
}
