/* com/syncbuilder/storage/mail/Record.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
* Copyright (C) 1998, Robert Crawford
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/

package com.syncbuilder.storage.mail;

import java.io.*;
import com.syncbuilder.util.*;

/**
* A representation of a mail database record.
*
* @author Kenneth Albanowski, Tilo Christ, Robert Crawford
*/
public class Record 
	extends com.syncbuilder.storage.Record 
{
	public Record() 
	{
		super();
	}

	public Record(byte[] contents, com.syncbuilder.storage.RecordID id, int index, int attr, int cat) 
	{
		super(contents, id, index, attr, cat);
	}

	public void unpack(byte[] data) {
		int index = 0;


		// FIXME
		int year = (int) ((data[0] & 0xfe) >> 1);
		year += 4;
		int month = (int) ( ( (data[0] & 0x01) << 2) |
					((data[1] & 0xE0) >> 5) );
		int day = (int) (data[1] & 0x1f);
		int hour = (int) data[2];
		int min = (int) data[3];
		date = new java.util.Date (year, month, day, hour, min);
		
		index += 4;

		//' read flags;
		byte flags = data[index];
		read = (flags & 0x80) != 0;
		signature = (flags & 0x40) != 0;
		confirmRead = (flags & 0x20) != 0;
		confirmDelivery = (flags & 0x10) != 0;

		priority = (flags & 0x0C0) >> 2;
		addressing = (flags & 0x03);

		index = 6;

		// read the subject
		Index idx = new Index();
		subject = PackUtils.getZeroTermString(data, index, idx);
		index = idx.getValue();
		from = PackUtils.getZeroTermString(data, index, idx);
		index = idx.getValue();
		to = PackUtils.getZeroTermString(data, index, idx);
		index = idx.getValue();
		cc = PackUtils.getZeroTermString(data, index, idx);
		index = idx.getValue();
		bcc = PackUtils.getZeroTermString(data, index, idx);
		index = idx.getValue();
		replyTo = PackUtils.getZeroTermString(data, index, idx);
		index = idx.getValue();
		sentTo = PackUtils.getZeroTermString(data, index, idx);
		index = idx.getValue();
		body = PackUtils.getZeroTermString(data, index, idx);
		}

	public native byte[] pack();

	public void fill() 
	{
	}

    public String describe() 
	{
        StringBuffer c = new StringBuffer("read=");
      return "read="+read+", signature="+signature+", confirmRead="+confirmRead+
             ", confirmDelivery="+confirmDelivery+", priority="+priority+
             ", addressing="+addressing+", date="+((date == null)?"<Null":date.toString())+
             ", from="+com.syncbuilder.util.Util.prettyPrint(from)+
             ", to="+com.syncbuilder.util.Util.prettyPrint(to)+
             ", cc="+com.syncbuilder.util.Util.prettyPrint(cc)+
             ", bcc="+com.syncbuilder.util.Util.prettyPrint(bcc)+
             ", replyTo="+com.syncbuilder.util.Util.prettyPrint(replyTo)+
             ", sentTo="+com.syncbuilder.util.Util.prettyPrint(sentTo)+
             ", body="+com.syncbuilder.util.Util.prettyPrint(body)+
             ", subject="+com.syncbuilder.util.Util.prettyPrint(subject)+
             ", "+super.describe();
    }

	public boolean read, signature, confirmRead, confirmDelivery;
	public int priority, addressing;

	public java.util.Date date;
	public String subject, from, to, cc, bcc, replyTo, sentTo, body;
}
