/* com/syncbuilder/storage/mail/SyncPref.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: SyncPref.java,v 1.1 1998/09/16 08:57:42 christ Exp $ */

package com.syncbuilder.storage.mail;

import java.io.*;

import com.syncbuilder.util.Util;

final public class SyncPref 
	extends com.syncbuilder.storage.Pref 
{
	public SyncPref() 
	{
		super(null, new com.syncbuilder.storage.Char4("mail"), 1, 1, true);
	}

	public SyncPref(boolean local) 
	{
		super(null, new com.syncbuilder.storage.Char4("mail"), local ? 1 : 2, 1, true);
	}

	public SyncPref(byte[] contents, com.syncbuilder.storage.Char4 creator, int id, int version, boolean backup) 
	{
		super(contents, creator, id, version, backup);
	}
		
	public void fill()
	{
		throw new Error("com.syncbuilder.storage.mail.SyncPref.fill() should never be invoked!");
	}


	public native void unpack(byte[] data);
	public native byte[] pack();
	                
		
	public String describe() 
	{
		return "syncType="+syncType+", getHigh=" +getHigh+", getContaining="+getContaining+", "+
			   "truncate="+truncate+", filterTo=" + Util.prettyPrint(filterTo) +
			   ", filterFrom=" + Util.prettyPrint(filterFrom) +
			   ", filterSubject=" + Util.prettyPrint(filterSubject)+", "+super.describe();
	}

	public sync syncType;
	public boolean getHigh;
	public boolean getContaining, truncate;
	public String filterTo, filterFrom, filterSubject;
}
