/* com/syncbuilder/storage/memo/AppBlock.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: AppBlock.java,v 1.2 1998/09/17 08:20:26 christ Exp $ */

package com.syncbuilder.storage.memo;

import java.io.*;

import com.syncbuilder.util.PackUtils;

/**
* The AppBlock for the MemoPad-application
*
* @author Kenneth Albanowski, massive changes by Tilo Christ
*/
public class AppBlock 
	extends com.syncbuilder.storage.CategoryAppBlock 
{
	public AppBlock() 
	{
		super();
	}
		
	public AppBlock(byte[] contents) 
	{
		super(contents);
	}

	public boolean getSortByAlpha()
	{
		return _sort_by_alpha;
	}
	
	public void setSortByAlpha( boolean sort_by_alpha )
	{
		this._sort_by_alpha = sort_by_alpha;
	}
			
	public void unpack(byte[] data)
		throws java.lang.IllegalArgumentException
	{
		if (data.length < com.syncbuilder.storage.CategoryAppBlock.LENGTH + 4)
			throw new java.lang.IllegalArgumentException("data-array too short!");

		super.unpack(data);
		
		_sort_by_alpha = (data[com.syncbuilder.storage.CategoryAppBlock.LENGTH + 2] != 0);		
	}
	
	public byte[] pack()
	{
		byte[] buf = new byte[com.syncbuilder.storage.CategoryAppBlock.LENGTH + 4];
		super.packCategories(buf);
		
		PackUtils.setShort(buf, com.syncbuilder.storage.CategoryAppBlock.LENGTH, 0); // gap-fill
		buf[com.syncbuilder.storage.CategoryAppBlock.LENGTH + 2] = (_sort_by_alpha) ? (byte)0xff : (byte)0x00; 
		buf[com.syncbuilder.storage.CategoryAppBlock.LENGTH + 3] = (byte)0; // gap-fill
		
		return buf;
	}


	public boolean equals(Object obj)
	{
		if (!(obj instanceof com.syncbuilder.storage.memo.AppBlock))
			return false;
			
		com.syncbuilder.storage.memo.AppBlock memo_app = (com.syncbuilder.storage.memo.AppBlock)obj;
		
		return (super.equals(obj)) && (_sort_by_alpha == memo_app.getSortByAlpha());
	}
	

	public String describe() 
	{
		return "sortByAlpha " + _sort_by_alpha + ", " + super.describe();
	}
	
	public String toString() 
	{
		return "<" + this.getClass().getName() + " " + describe() + ">";
	}

	private boolean _sort_by_alpha;
}

