/* com/syncbuilder/storage/memo/DatabaseImpl.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: DatabaseImpl.java,v 1.1 1998/09/16 08:57:42 christ Exp $ */

package com.syncbuilder.storage.memo;

/**
* The DatabaseImpl for use with the Pilot's built-in Memopad-application
*
* @author Kenneth Albanowski, changes by Tilo Christ 
*/
public class DatabaseImpl
	extends com.syncbuilder.storage.DatabaseImpl
{
	public com.syncbuilder.storage.AppBlock createAppBlock() 
		{ return new com.syncbuilder.storage.memo.AppBlock(); }
		
	public com.syncbuilder.storage.AppBlock createAppBlock(byte[] contents) 
		{ return new com.syncbuilder.storage.memo.AppBlock(contents); }
	
	public com.syncbuilder.storage.Record createRecord() 
		{ return new com.syncbuilder.storage.memo.Record(); }
		
	public com.syncbuilder.storage.Record createRecord(byte[] contents, com.syncbuilder.storage.RecordID id, int index, int attr, int cat) 
		{ return new com.syncbuilder.storage.memo.Record(contents, id, index, attr, cat); }
		
	public com.syncbuilder.storage.Char4 getCreatorID() 
		{ return _CREATOR_ID; }
		
	public String getDBName() 
		{ return "MemoDB"; }

	
	private final static com.syncbuilder.storage.Char4 _CREATOR_ID = new com.syncbuilder.storage.Char4("memo");
}
