/* com/syncbuilder/storage/todo/AppBlock.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: AppBlock.java,v 1.1 1998/09/16 08:57:42 christ Exp $ */

package com.syncbuilder.storage.todo;


/**
* The AppBlock for the PalmPilot's To-Do Application.
*
* @author Kenneth Albanowski, changes by Tilo Christ
*/
public class AppBlock 
	extends com.syncbuilder.storage.CategoryAppBlock 
{
	public AppBlock() 
	{
		super();
	}
		
	public AppBlock(byte[] contents) 
	{
		super(contents);
	}
	
	public void unpack(byte[] data)
	{
		if (data.length < com.syncbuilder.storage.CategoryAppBlock.LENGTH + 4)
			throw new java.lang.IllegalArgumentException("data-array too short!");

		super.unpack(data);
		
		dirty = (data[com.syncbuilder.storage.CategoryAppBlock.LENGTH] != (byte)0 ||
			data[com.syncbuilder.storage.CategoryAppBlock.LENGTH + 1] != (byte)0);
			
		sortByPriority = data[com.syncbuilder.storage.CategoryAppBlock.LENGTH + 2] != (byte)0;
	}
	
	public byte[] pack()
	{
		byte[] buf = new byte[com.syncbuilder.storage.CategoryAppBlock.LENGTH + 4];
		super.packCategories(buf);
		
		buf[com.syncbuilder.storage.CategoryAppBlock.LENGTH]     = (byte)((dirty) ? 0xff : 0x00);
		buf[com.syncbuilder.storage.CategoryAppBlock.LENGTH + 1] = (byte)((dirty) ? 0xff : 0x00);
		buf[com.syncbuilder.storage.CategoryAppBlock.LENGTH + 2] = (byte)((sortByPriority) ? 0xff : 0x00);
		buf[com.syncbuilder.storage.CategoryAppBlock.LENGTH + 3] = (byte)0; // gap-fill
		
		return buf;
	}

	public boolean equals(Object other)
	{
		if (!(other instanceof com.syncbuilder.storage.todo.AppBlock))
			return false;
			
		com.syncbuilder.storage.todo.AppBlock other2 = (com.syncbuilder.storage.todo.AppBlock)other;
		
		if (!super.equals(other2))
			return false;
			
		if (sortByPriority != other2.sortByPriority)
			return false;
			
		if (dirty != other2.dirty)
			return false;
			
		return true;
	}
		
	public String describe() 
	{
		return "sortByPriority="+sortByPriority+ ", dirty=" + dirty + ", " + super.describe();
	}

	public boolean sortByPriority;
	public boolean dirty;
}
