/* com/syncbuilder/sync/DlpException.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: DlpException.java,v 1.1 1998/09/16 08:57:44 christ Exp $ */

package com.syncbuilder.sync;

/**
* This checked exception indicates a problem with the HotSync.
*
* @author Kenneth Albanowski, changes by Tilo Christ
*/
public class DlpException 
	extends Exception 
{
	/**
	* Only DlpImpl shall construct these exceptions.
	*/
	public DlpException() 
	{ 
		super(); 
	}

	/**
	* Only DlpImpl shall construct these exceptions.
	*/
	public DlpException(String s) 
	{ 
		super(s);
	}
	/**
	* Only DlpImpl shall construct these exceptions.
	*/
	public DlpException(int code) 
	{
		super((code < error_strings.length) ? error_strings[code] : "Unknown DLP problem");
		this.code = code;
	}

	/**
	* Don't remove!!! Used by the native interface.
	*/
	public static void kickWillyScuggins(int code) 
		throws DlpException 
	{
		throw new DlpException(code);
	}

	
	public int code;

	private final static String[] error_strings =
	{
	  "No error",
	  "General System error",
	  "Illegal Function",
	  "Out of memory",
	  "Invalid parameter",
	  "Not found",
	  "None Open",
	  "Already Open",
	  "Too many Open",
	  "Already Exists",
	  "Cannot Open",
	  "Record deleted",
	  "Record busy",
	  "Operation not supported",
	  "-Unused-",
	  "Read only",
	  "Not enough space",
	  "Limit exceeded",
	  "Sync cancelled",
	  "Bad arg wrapper",
	  "Argument missing",
	  "Bad argument size"
	};
}
