/* com/syncbuilder/sync/SocketImplFactory.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: SocketImplFactory.java,v 1.1 1998/09/16 08:57:45 christ Exp $ */

package com.syncbuilder.sync;

/**
* This interface defines a factory for socket implementations. 
* It is used by the classes <code>Socket</code> and <code>ServerSocket</code> 
* to create actual socket implementations. 
*
* @see com.syncbuilder.sync.Socket
* @see com.syncbuilder.sync.ServerSocket
* @see com.syncbuilder.sync.SocketImpl
*
* @author Tilo Christ
*/
public interface SocketImplFactory
{
	/**
	* Creates a new <code>com.syncbuilder.sync.SocketImpl</code> instance
	*/
	public SocketImpl createSocketImpl();
}
