/* com/syncbuilder/util/Util.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
* Copyright (C) 1998, Robert Crawford
*
* This is free software, licensed under the GNU Library Public License V2.
* See the file COPYING.LIB for details.
*/
/* $Id: Util.java,v 1.2 1998/12/09 09:43:21 christ Exp $ */

package com.syncbuilder.util;

/**
* A collection of helper methods, mostly for debugging output.
*
* @author Kenneth Albanowski, Tilo Christ, Robert Crawford
*/
final public class Util 
{
	static public String hexPrint(byte[] b)
	{
		return hexPrint(b, b.length);
	}

	static public String hexPrint(byte[] b, int len)
	{
		if (len > b.length)
			len = b.length;

		StringBuffer out = new StringBuffer();
		
		for( int i=0; i < len; i += 10 )
		{
			int j;
			for (j = 0; (i + j) < len && j < 10; j++) {
				int num = b[i + j] & 0xff;
				String str = "00" + Integer.toHexString(num);
				out.append(str.substring(str.length() -2,
						str.length()));
				out.append(" ");
				}
			for (; j < 10; j++) {
				out.append("   ");
				}
			out.append("     ");
			for (j = 0; (i + j) < len && j < 10; j++) {
				int num = b[i + j] & 0xff;
				char c = (char) num;
				if (c == 13) {
					out.append("\\r");
					} 
				else if (c == 10) 
				{
					out.append("\\n");
				} 
				else if (c == 8) 
				{
					out.append("\\b");
				} 
				else if (c == 9) 
				{
					out.append("\\t");
				} 
				else if (c < 32) 
				{
					out.append('^');
					out.append((char)(c ^ 64));
				} 
				else if (c > 126) {
					out.append("\\x");
					out.append(Integer.toHexString(c));
					} 
				else {
					out.append(c);
					}
				}
			out.append("\n");
		}
		
		return out.toString();
	}

	static public String prettyPrint(byte[] b)
	{ 
		return prettyPrint(new String(b,0,b.length)); 
	}

	static public String prettyPrint(Object o) 
	{
		if (o == null) 
		{
			return "null";
		}
		
		char[] c = o.toString().toCharArray();
		StringBuffer out = new StringBuffer();
		for (int i=0;i<c.length;i++) 
		{
			if (c[i] == 13) 
			{
				out.append("\\r");
			} 
			else if (c[i] == 10) 
			{
				out.append("\\n");
			} 
			else if (c[i] == 8) 
			{
				out.append("\\b");
			} 
			else if (c[i] == 9) 
			{
				out.append("\\t");
			} 
			else if (c[i] < 32) 
			{
				out.append('^');
				out.append((char)(c[i] ^ 64));
			} 
			else if (c[i] > 126) 
			{
				out.append("\\x");
				out.append(Integer.toHexString(c[i]));
			} 
			else 
			{
				out.append(c[i]);
			}
		}
		
		return out.toString();
	}
	
    static public String readLine() 
		throws java.io.IOException 
	{
        java.io.BufferedReader dis = new java.io.BufferedReader(new java.io.InputStreamReader(System.in));

        return dis.readLine();
    }


	private Util()
	{
	}
}
