#include "shortcuts.h"
#include "menubar.html"
<h3>Will SyncBuilder work under Windows 95?</H3>
I cannot give a definitive answer to that one, because I am not using Windows 95.
The pure Java version for Windows NT may or may not work.
Since the Windows version of SyncBuilder only supports Network HotSync you will 
have to come up with a way to establish a TCP/IP connection to your Windows 95
machine through PPP dial-in. 

<h3>Will SyncBuilder work on Solaris (or other Unices)?</h3>
Yes. Even the native support code should compile and work on many commercial
Unices. This will allow you to enjoy the full functionality of SyncBuilder
on these platforms. I cannot give you any assistance with building the
proper cables though.

<h3>Is SyncBuilder written in Pure Java?</h3>
Large portions of SyncBuilder have been developed using the Java language and
the Java class-libraries, as provided by JavaSoft. These Java portions enable
lots of functionality on all platforms. On Unix platforms there is also native
support code which will give you extra functionality (most notably, the ability
to synchronize through a direct serial cable). It is up to you whether you
choose to install this native code. The framework will install and run without
that native code, it will just be limited in its functionality.<br>
SyncBuilder has <i>not</i> been certified for the <i>100% Pure Java</i> seal of approval.

<h3>Can I use SyncBuilder to synchronize with MS Access?</h3>
SyncBuilder is only concerned with the connectivity to the PALMPILOTS. It can
establish connections, and it can read and write data to and from the PALMPILOT.
It is up to you to develop custom code that synchronizes with a database or
any other data-source on your host. You might want to read Palm Computings 
documentation on developing Conduits to get an idea about the issues which are
involved.
<p>
To finally answer the question: Yes, it can connect with MS Access (through
JDBC-ODBC), but you will have to write your own code to do so. 

<h3>Can SyncBuilder handle many simultaneous connections?</h3>
Yes! SyncBuilder has been built with support for simultaneous connections from the ground up! 
Special measures have been taken to make this a reality even on those platforms which
offer poor Java multi-threading (older Unices, Linux).<br>
Simultaneous connections require the use of the Network HotSync technology, though. You will therefore
have to setup PPP dial-in on your host and you will have to install the
Network HotSync software (I tested version 3.0) on your handheld.<br>
Once you have done that, everything should be fine. 

<h3>Which devices can be used with SyncBuilder?</h3>
SyncBuilder can work together with all Palm Computing<sup>(R)</sup> 
platform devices. This includes, but is not limited to, the
Pilot&nbsp;1000, the Pilot&nbsp;5000, the PalmPilot&nbsp;Personal&nbsp;connected&nbsp;organizer,
the PalmPilot&nbsp;Professional&nbsp;connected&nbsp;organizer, the PalmIII&nbsp;connected&nbsp;organizer,
the IBM&nbsp;WorkPad&nbsp;PC&nbsp;companion, the IBM&nbsp;WorkPad&nbsp;II&nbsp;PC&nbsp;companion, and the 
Symbol&nbsp;SPT1500.
<p>
Synchronization across a network can only be accomplished on those devices
which include a TCP/IP stack in their operating system (Palm OS 2.0, or better).

<H3>What future plans do you have?</H3>
The development is going in several directions:
<UL>
<LI>
Improvements to the foundation</LI>

<LI>
Conduit SDK</LI>

<LI>
Pure Java code</LI>
</UL>

<DT>
<B>Improvements to the foundation:</B></DT>

<DD>
PILOTLINK already comes with a working JAVA-binding. This original
binding is quite decent, but one can imagine many improvements. I have
taken the original binding and I am remodelling those parts where I feel
they deserve it. The result is called the JAVALINK_LONG.</DD>

<DT>
<B>Conduit SDK:</B></DT>

<DD>
On the Win32 platform and on the Macintosh platform you can use the HOTSYNC
which is supported by application-specific <I>Conduits</I>. Initial support
for a similar mechanism is now part of the JAVALINK distribution, but this
technology will certainly mature over the course of time.
</DD>

<DT>
<B>Pure Java code:</B></DT>

<DD>
JAVALINK currently comes with native support code for the Unix platform,
which gives it additional value on that platform. 
I could very well imagine a version which uses pure Java and Suns CommAPI instead. 
The CommAPI is available for a multitude of platforms, including UNIX, and Win32. 
This port would be a major piece of work, and I could use any help I can get.<br>
Support for Network HOTSYNC through the java.net.*-classes is fully functional, 
though, and is included in this distribution.</DD>
#include "footer.html"
