#include "shortcuts.h"
#include "menubar.html"
These instructions have been tested on an Intel LINUX box, running RedHat 5.0, as well as the JDK 1.1.6v1, 
JDK 1.1.6v4a, and JDK 1.1.6v5 from <A HREF="http://www.blackdown.org">http://www.blackdown.org</A>. A similar 
installation procedure should work on most other Unices too. You are welcome to contribute more specific 
instructions for other Unix platforms!
<h3>Installation of the pure Java code only</h3>
Unpack the download archive into a place of your liking.
Include the file <tt>Java/SyncBuilder.jar</tt> into your
CLASSPATH environment variable. Then <a href="#checking">check for successful installation</a>.
<h3>Installation of both Java and native code</h3>
<i>
Personally, I use IBMs blindingly fast jikes compiler for LINUX.
It works great for compiling JAVALINK. The configuration procedure
during the source code installation will try to detect jikes in your PATH and
will use it for building the package if it is available.
<br>
The Jikes compiler may be downloaded for free
at <A HREF="http://www.alphaworks.ibm.com/formula">http://www.alphaworks.ibm.com/formula</A>.
<p>
Of course, you will also be fine if you use the javac compiler.
</i>
<p>
<B>Please tell me, if these instructions dont work for you.</B>
<P>
Unpack PILOTLINK first. Choose a directory and say <TT>tar -zxvf PLTAR</TT>.
Make sure you have the proper permissions to overwrite the <TT>PLDIR</TT> directory
and all of its sub-directories.
<P>Change to the <TT>PLDIR</TT> directory. Say <TT>rm -rf
Java</TT>. 
Copy
<TT>Java.tar.gz </TT>to the <TT>PLDIR</TT> directory.
Say <TT>tar -zxvf Java.tar.gz</TT>. This will unpack the new binding
and the updated
<TT>configure.in</TT> and <TT>configure</TT> files. It
will also <I>DOWNGRADE</I> the libtool-files from libtool 1.2 to libtool
1.0c. Using the libtool 1.2 that comes with PILOTLINK breaks both
the PILOTLINK JAVA-binding as well as JAVALINK.
<P>
Say <TT>configure --with-java=<I>xxx</I></TT>
where <I>xxx </I>is the directory which contains your JDK 1.1. Make sure
<TT>configure</TT>
locates your JDK properly. Run <TT>make</TT>. Watch the make-process.
Run <TT>make install</TT>. Make sure, the software and shared-libraries
end up in places which are in your path and your library-path respectively
(typically, they will install to <TT>/usr/local/bin</TT> and
<TT>/usr/local/lib</TT>).
The installation step will most likely require root-status.
<P>Now change to the <TT>Java</TT>-subdirectory. Run <TT>make</TT>. The
JAVALINK packages will be compiled.

<a name="checking"><h3>Checking for successful installation</h3>
Make sure the current directory (<tt>.</tt>) is included in your CLASSPATH environment
variable! Then change to the <tt>Java/samplecode</tt> directory.
Execute <TT>java dlptest</TT>. This will run the PALMPILOT through
a short series of tests.<br>
<h4>Checking Serial HotSync</h4>
This will only work if you did the installation of the native code. When asked for the
port on which your PALMPILOT is connected, choose the UNIX device-name of the serial
port to which the cradle is connected (e.g. /dev/ttyS0, or /dev/pilot).<br>
While the instructions and explanations are being displayed, be sure not to wait too long 
to press &lt;RETURN&gt;, otherwise the connection will time out!
<h4>Checking Network HotSync</h4>
This will work for both the pure Java installation as well as the native installation. 
You will have to install the Network HotSync software on your PALMPILOT though, and run 
the pppd (both is described <a href="palmos_networking.html">here</a>).<br>
When asked for the port to which your PALMPILOT is connected choose <tt>.</tt> (dot). You will
then be asked to instantiate the Network HotSync. You do this by tapping on the &quot;Modem HotSync&quot;
symbol on your PALMPILOT. The pppd should already be running before you start the JAVA application. 
<H3>
Troubleshooting</H3>

<PRE><B>java.lang.UnsatisfiedLinkError: no JavaPisock in shared library path</B></PRE>

<DD>
The native code for the Java-binding could not be located. If you have only done the binary
installation this will happen anytime you try to access functionality that requires native
support code (e.g. synchronization through the serial cable).<br>
If you have successfully installed the source version though then you should try to
manually add <TT>PLDIR/Java/_libs</TT> to your <TT>LD_LIBRARY_PATH</TT>.
You might also have to run <TT>ldconfig</TT> as root, to make the new library
known to the system. This will be fixed at a later time by an install-target
in the Makefile.</DD>

<PRE><B>java.lang.UnknownError
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; at Pdapilot.ServerSocket.bind(ServerSocket.java:xx)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; at Pdapilot.ServerSocket.<init>(ServerSocket.java:xx)
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; at pltests.fulldemo.main(fulldemo.java:xx)</B></PRE>

<DD>
The specified port for the PALMPILOT could not be found. The default
is <TT>/dev/pilot</TT>, which is probably not present on your system. You
might wish to create <TT>/dev/pilot</TT> by typing <TT>ln -s /dev/ttyS0
/dev/pilot</TT>.</DD>
<p>

#include "footer.html"
