#include "shortcuts.h"
#define PALMOS_NETWORKING_PAGE
#include "mainmenu.html"
<H1>
Networking with your Palm Computing platform device</H1>
Palm Computing platform devices from the PalmPilot Professional up (PalmPilot&nbsp;Professional&nbsp;connected&nbsp;organizer,
PalmIII&nbsp;connected&nbsp;organizer, IBM&nbsp;WorkPad&nbsp;PC&nbsp;companion, IBM&nbsp;WorkPad&nbsp;II&nbsp;PC&nbsp;companion, Symbol&nbsp;SPT1500) 
contain a TCP/IP stack which allows
them to dial-up via PPP and then utilize this connection for e-mail and
other applications (e.g. Telnet, WWW browsing). The TCP/IP stack is also
being used for a special mode of synchronization, called Network HotSync. Network
HotSync allows one to do remote synchronization with any machine that can be
reached through a PPP terminal-server and/or a TCP/IP-network.
<P>Here are a few useful pointers to information that is related to TCP/IP
dial-up and Network HotSync.
<BR>&nbsp;
<H2>
Network HotSync</H2>
The software which is neccessary for Network HotSync is not included with
the PalmPilot Professional or the PalmIII. PalmIII users may download the
software at <A HREF="http://palm.3com.com/custsupp/downloads/netsync.html">Palms
web-site</A>. PalmPilot Professional users who wish to play it safe need
to purchase the Network HotSync software for $69. Those who do not care
about Palms claim that there is no way this software could possibly work
on a PalmPilot Professional may use the same link to get the same software.
It worked great on my PalmPilot Professional, but your mileage may vary.
<BR>&nbsp;
<H2>
Local Dial-Up</H2>
For the purpose of software-development (testing, debugging), you may wish
to establish a PPP-connection without employing a modem. This is entirely
possible. Your PALMPILOT comes with a null-modem cable (cleverly disguised
as a 'cradle') and that is all the hardware you need<B>.</B>
<BR><B>CAUTION:</B> You need to use a <B>null-modem cable</B>! You can
use either the cradle or the HotSync cable, but you cannot use the <B>modem-cable</B>.
<BR>The PalmPilots serial sub-system is rather weak. Do not expect to
reach very high transmission speeds. My own device reached a whopping 19,200
with the built-in software, and a full 57,600 with DirectLink.
<BR>It is entirely possible to do a Network HotSync over a TCP/IP
connection which you have already established before. This means, you can establish
a connection through the DirectLink software and then initiate the Network HotSync
procedure in order to enjoy great through-put!
<BR>&nbsp;
<H3>
DirectLink</H3>
DirectLink is an addition for the PalmPilots built-in PPP software. It
is only suitable for a local null-modem connect (cannot be used with a
real modem). Through some kind of magic it allows you to reach connection-speeds
that you could otherwise only dream of (57,600).
<P>Download DirectLink from <A HREF="http://www.metasync.com/pilot/vitallink.html">http://www.metasync.com/pilot/vitallink.html</A>.
<BR>
<h3>Network HotSync over DirectLink</h3>
<i>This piece of wisdom has been contributed by Emmanuel Pirsch</i>
<p>
I can connect to my desktop with DirectLink, then I go to the Hotsync
App. You have to select the <i>SAME</i> network connection than the one used by
DirectLink (that is the last one used) then you press the Modem Sync
Graphic Button and it WORKS.
<br>
Also a quick way to go to the hotsync app once youre connected with
DirectLink is to press the hotsync button on the cradle, the hot sync app
will appear with a message telling you that the serial port is already in
use, press OK then press on the Modem Sync graphic button.
<br>
<b>The thing to remember is that the network connection selected in the
hotsync app should be the same as the one used by DirectLink.</b>
<p>
I can confirm that this trick works with my own setup. Thanks Emmanuel!

<H3>
Linux pppd</H3>
The pppd software that comes with Linux allows you to establish a working
PPP connection. It can serve a modem, but it also allows you to establish a 
local connection through a null-modem cable.
<P>
Do this on your Linux box (assuming the name of your serial device is
/dev/ttyS0):
<BR>
<TT>/usr/sbin/pppd /dev/ttyS0 19200 persist -detach crtscts local passive 10.0.0.1:10.0.0.2</TT>
<br>
The pppd-daemon will run in an endless loop, accepting one connection after the other. If you want
it to accept only one connection and then quit you need to omit the <tt>persist</tt> option.
<P>
On your PalmPilot set up PPP with an empty login and empty password.
Set the phone-number to '00'. This will start PPP w/ a null-modem (no dialling,
no waiting for a CONNECTED-message). If you wish to run the Network HotSync software you will
also have to set the appropriate parameters for the remote PC to which you wish to sync (IP 10.0.0.1, 
leave the name blank).
<P>If these instructions should fail to work, there may be numerous reasons.
Try to lower the speed from 19,200 to 9,600. Check out the debug-messages
from pppd (use the debug-option). Make sure no CHAP or PAP-authentification
is required.
<P>If the connection has been established you should see a small blinking
vertical bar in the upper-right corner of your PalmPilots display.
<BR>&nbsp;
<H3>
Windows NT RAS Server</H3>
Windows NT comes with the RAS-server software which allows you to establish
PPP connections between your PalmPilot and your WINNT box. I have tried
the instructions from the link below and they worked for me (I am using
Windows NT 4.0 SP3 Workstation). This setup allowed me to successfully
do a Network HotSync with both the Palm Desktop 3.0 and with my own JAVALINK
software. 
<P>
<A HREF="http://www.almaden.ibm.com/cs/TSpaces/Pilot/NTRAS.html">http://www.almaden.ibm.com/cs/TSpaces/Pilot/NTRAS.html</A>
<p>
In addition to the method described in this document I also managed to install
Palms free MSCHAP extension onto my PalmPilot Professional, which allowed me
to use encrypted Challenge-Response authentification. Palm recommends to upgrade
PalmOS to version 2.0.5 or 3.0.2 if you wish to use WINNT RAS, which I have done.
<H2>
Modem dial-up</H2>

<H3>
Modem hooked up to the Palm device</H3>
You can easily hook up an off-the-shelf modem to your Palm device. I
tried this with a US-Robotics Sportster and it worked quite well. All you
need is the special modem-cable from 3COM. You can also use an adapter
that turns null-modem-cables into modem-cables and put that adapter between
your cradle and your modem.
<H3>
Modem hooked up to the PC</H3>
If you have a Win32 system with both a cradle and a modem you can install
the <B><I>PilotNet </I></B>software on your machine. This will allow your
PALMPILOT to reach your modem through your PC. The software may be found
at the following URL (I havent tried it out):<A HREF="http://members.xoom.com/PilotProgs/"></A>
<P><A HREF="http://members.xoom.com/PilotProgs/">http://members.xoom.com/PilotProgs/</A>
<BR><I><A HREF="http://members.xoom.com/PilotProgs/"></A></I>&nbsp;<FONT COLOR="#000000"><A HREF="http://members.xoom.com/PilotProgs/"></A></FONT>

<H3>
Complete replacement for Network HotSync technology</H3>
<a href="http://www.waveware.net">Waveware</a> has announced a package called 
<a href="http://www.waveware.net/wavesync.html">WaveSync</a> which is supposed to be a complete replacement 
for Palm Computings Network HotSync technology on both the PALMPILOT and on the host. WaveSync can work
with existing conduits, but it is capable of synchronizing several PALMPILOTS at the same time, with added
security, faster data-transfer, and better user-management features.<br>
Waveware is currently looking for beta-sites.

#include "footer.html"
