/* samplecode/datesucker.java:
*
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Public License V2.
* See the file COPYING for details.
*/
/* $Id: datesucker.java,v 1.1 1998/09/16 08:57:50 christ Exp $ */

import java.io.*;

/**
* Suck all datebook-entries out of the Pilot and write them to a file.
* The file will contain an appointment-AppBlock, followed by several 
* consecutive appointment.Record-objects in serialized form.
*
* @author Tilo Christ
*/
public class datesucker
{
	public static void main(String[] args) 
	{
	try
	{
		System.out.print("Port to use [/dev/pilot]? ");
		System.out.flush();
		
		String port = com.syncbuilder.util.Util.readLine();

		if (port.equals("")) 
			port = "/dev/pilot";

		FileOutputStream ostream = new FileOutputStream( args[0] );
		ObjectOutputStream p = new ObjectOutputStream(ostream);

		System.out.println("Please hit the HotSync button now.");
		
		com.syncbuilder.sync.ServerSocket servsock = new com.syncbuilder.sync.ServerSocket(port);
		com.syncbuilder.sync.Dlp dlp = servsock.accept().getDlp();
		
		dlp.switchMessage();
		
		com.syncbuilder.storage.Database z = dlp.openStockDB(new com.syncbuilder.storage.appointment.DatabaseImpl());

		// Retrieve and persist the AppBlock
		com.syncbuilder.storage.appointment.AppBlock ab =
			(com.syncbuilder.storage.appointment.AppBlock)z.getAppBlock();
		System.out.println("AppBlock: " + ab.describe());
		p.writeObject( ab );
				
		// Retrieve and persist the Records
		for (int i=0;;i++) 
		{
			com.syncbuilder.storage.appointment.Record q = 
				(com.syncbuilder.storage.appointment.Record)z.getRecord(i);

			if (q == null)
				break;

			System.out.println("Descr: " + com.syncbuilder.util.Util.hexPrint( q.description.getBytes() ));
			
			System.out.println("Note: " + ((q.note != null) ? (com.syncbuilder.util.Util.hexPrint( q.note.getBytes() )) : ""));

			System.out.println("Writing Record #" + i +": " + q.toString() );
			p.writeObject( q );
		}
		
		System.out.println("Ending HotSync...");

		dlp.endHotSync();

		System.out.println("Done!");

		servsock.close();

		p.flush();
		ostream.close();

		} catch (java.lang.Throwable e)
		{
			e.printStackTrace();
		}
	}
}

