/* samplecode/demo1.java:
*
* Copyright (C) 1997, 1998, Kenneth Albanowski
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Public License V2.
* See the file COPYING for details.
*/
/* $Id: demo1.java,v 1.2 1998/12/09 09:42:26 christ Exp $ */


import java.io.*;
import com.syncbuilder.sync.*;
import com.syncbuilder.storage.*;
import com.syncbuilder.util.Util;

/**
* This is a demo-program, that exercises some of the functionality
* of the Palm device. 
*
* @author Kenneth Albanowski, changes by Tilo Christ
*/
public class demo1
{
	public static void main(String[] args) 
	{
	try
	{
		System.out.println( com.syncbuilder.PackageInfo.getDisclaimer() );
			
		System.out.print("Port to use [/dev/pilot]? ");
		System.out.flush();
		
		String port = Util.readLine();

		if (port.equals("")) 
			port = "/dev/pilot";

		System.out.println("Please hit the HotSync button now.");
		
		ServerSocket ssock = new ServerSocket(port);

		Link link = ssock.accept();
		Dlp dlp = link.getDlp();
		
		System.out.println(dlp.getTime().toString());
		System.out.println(dlp.getUserInfo().toString());
		System.out.println(dlp.getSysInfo().toString());
		
		for (int i=0;;i++) 
		{
			com.syncbuilder.device.CardInfo c = dlp.getCardInfo(i);

			if (c == null)
				break;

			System.out.println("Card #" + i + ": " + c.toString() );
		}

		for (int i=0;;i++) 
		{
			DBInfo d = dlp.getDBInfo(i, true, true, 0);

			if (d == null)
			{
				break;
			}

			System.out.println("DB #" + i + ": " + d.toString() );
		}
	
		
		Database dbase = dlp.openStockDB(new com.syncbuilder.storage.appointment.DatabaseImpl());
		
		RecordID ids[] = dbase.getRecordIDs(false, 0, 0xffff);
		for (int i=0;i<ids.length;i++) 
		{
			System.out.print(ids[i].toString()+" ");
		}
		System.out.println("");
		
		System.out.println(dbase.getAppBlock().toString());


		// Application preferences are identified by a number.
		// We try to obtain Prefs 0-3.
		Pref pref;

		pref = dbase.getPref(0);
		if (pref != null)
			System.out.println(pref.toString());
		pref = dbase.getPref(1);
		if (pref != null)
			System.out.println(pref.toString());
		pref = dbase.getPref(2);
		if (pref != null)
			System.out.println(pref.toString());
		pref = dbase.getPref(3);
		if (pref != null)
			System.out.println(pref.toString());
		
		for (int i=0;;i++) {
			Record record = (Record)dbase.getRecord(i);
			if (record == null)
				break;
			System.out.println("Record #" + i +": " + record.toString() );
		}
		
		com.syncbuilder.storage.expense.Record new_record = new com.syncbuilder.storage.expense.Record();
		new_record.payment = com.syncbuilder.storage.expense.payment.Check;
		
		System.out.println(new_record);
		
		dlp.endHotSync();
		
		System.out.println("Done!");

		} catch (java.lang.Throwable e)
		{
			e.printStackTrace();
		}
	}
}

