/* samplecode/todosucker.java:
*
* Copyright (C) 1998, Tilo Christ
*
* This is free software, licensed under the GNU Public License V2.
* See the file COPYING for details.
*/
/* $Id: todosucker.java,v 1.1 1998/09/16 08:57:51 christ Exp $ */


import java.io.*;
import com.syncbuilder.sync.*;
import com.syncbuilder.storage.*;
import com.syncbuilder.util.Util;

/**
* Suck all todo-entries out of the Pilot and write them to a file.
* The file will contain the todo-AppBlock, followed by several consecutive 
* todo.Record-objects in serialized form.
*
* @author Tilo Christ
*/
public class todosucker
{
	public static void main(String[] args) 
	{
	try
	{
		System.out.print("Port to use [/dev/pilot]? ");
		System.out.flush();
		
		String port = Util.readLine();

		if (port.equals("")) 
			port = "/dev/pilot";

		FileOutputStream ostream = new FileOutputStream( args[0] );
		ObjectOutputStream p = new ObjectOutputStream(ostream);

		System.out.println("Please hit the HotSync button now.");
		
		ServerSocket ssock = new ServerSocket(port);
		Dlp dlp = ssock.accept().getDlp();

		dlp.switchMessage();		
		
		Database dbase = dlp.openStockDB(new com.syncbuilder.storage.todo.DatabaseImpl());

		// Retrieve and persist the AppBlock
		com.syncbuilder.storage.todo.AppBlock ab =
			(com.syncbuilder.storage.todo.AppBlock)dbase.getAppBlock();
		System.out.println("AppBlock: " + ab.describe());
		p.writeObject( ab );
								
		for (int i=0;;i++) 
		{
			com.syncbuilder.storage.todo.Record record = 
				(com.syncbuilder.storage.todo.Record)dbase.getRecord(i);

			if (record == null)
				break;

			System.out.println("Descr: " + Util.hexPrint( record.description.getBytes() ));
			
			System.out.println("Writing Record #" + i +": " + record.toString() );
			p.writeObject( record );
		}
		
		dlp.endHotSync();
		
		System.out.println("Done!");

		p.flush();
		ostream.close();

		} catch (java.lang.Throwable e)
		{
			e.printStackTrace();
		}
	}
}

