#!/bin/sh
# This file builds a complete distribution for placement on the web-site
# In preparation to running this script you should make sure, that the
# CVS repository is up to date.
#
# $Id: build_dist.sh,v 1.5 1998/11/03 07:54:54 christ Exp $
TARGET=/tmp/java-link

echo Preparing target directory $TARGET
echo Press Ctrl-C to stop, or \<RETURN\> to proceed.
read
rm -rf $TARGET
mkdir $TARGET
mkdir $TARGET/downloads

echo Refreshing Makefile from Makefile.in
( cd .. ; ./config.status )

echo Cleaning up in preparation of next build-step
make clean

echo Building Java/JNI-stubs to prepare for dependency creation
make stubs

echo Building list of dependencies
make depend

echo Cleaning up in preparation of next build-step
make clean

echo Rebuilding library and utilities from scratch
make redoconst
make

echo Creating documentation and web-site contents
make docs
(cd docs/website/parts ; ./build_site.sh )
(source /etc/sgml/sgml.env ; cd docs/user ; make )

echo Creating Binary, Examples and Doc distributions
find com -name "*.class" -print | tar -czvf $TARGET/downloads/_temp_JBinaries.tar.gz -T - 
find samplecode -name "*.java" -print | tar -cvf $TARGET/downloads/Examples.tar -T - 
find samplecode -name "*.class" -print | tar -rvf $TARGET/downloads/Examples.tar -T - 
gzip $TARGET/downloads/Examples.tar

find . -name "*.html" -print | tar -cvf $TARGET/downloads/Documentation.tar -T -
find . -name "*.gif" -print | tar -rvf $TARGET/downloads/Documentation.tar -T -
find . -name "*.jpg" -print | tar -rvf $TARGET/downloads/Documentation.tar -T -
gzip $TARGET/downloads/Documentation.tar

( cd $TARGET/downloads ; tar -zxvf _temp_JBinaries.tar.gz ; jar -cv0f SyncBuilder.jar com ; rm -rf com )
rm $TARGET/downloads/_temp_JBinaries.tar.gz

echo Cleaning up in preparation of next build-step 
make clean
rm Makefile

echo Creating Full Developer \(Source, Binaries, and Doc\) distribution
(tar -xzvf $TARGET/downloads/Examples.tar.gz; cp $TARGET/downloads/SyncBuilder.jar . ; cd .. ; tar -czvf $TARGET/downloads/Java.tar.gz --exclude .snprj --exclude Java.proj Java configure configure.in scripts/ltmain.sh scripts/ltconfig )
rm SyncBuilder.jar

echo Creating Grand Unified Installer
rm -rf /tmp/datazipper
mkdir /tmp/datazipper
cp $TARGET/downloads/Java.tar.gz /tmp/datazipper
(cd /tmp/datazipper ; tar -zxvf Java.tar.gz ; rm Java.tar.gz ; java -classpath /usr/local/jdk1.1/lib/classes.zip:.:/usr/local/JInstallTK/Projects/SyncBuilder zip -r -c /usr/local/JInstallTK/Projects/SyncBuilder/data.zip "*" )
rm -rf /tmp/datazipper
(cd /usr/local/JInstallTK/Projects/SyncBuilder ; make build ; cp install/install.class $TARGET/downloads/install.class)

echo Removing currently unwanted stuff from web-site
rm $TARGET/downloads/Examples.tar.gz
rm $TARGET/downloads/Documentation.tar.gz

echo Transferring web-site
cp docs/website/*.html $TARGET
cp docs/website/*.gif $TARGET
cp docs/website/*.jpg $TARGET
(cd docs ; tar -cvf $TARGET/api.tar api ; cd $TARGET ; tar -xvf api.tar ; rm api.tar )
(cd docs ; tar -cvf $TARGET/user.tar user ; cd $TARGET ; tar -xvf user.tar ; rm user.tar )
(cd /usr/local/cvs ; tar -cvf $TARGET/repository.tar repository ; cd $TARGET ; tar -xvf repository.tar ; rm repository.tar)
mkdir $TARGET/cgi-bin
cp /usr/local/src/cgi-style.pl $TARGET/cgi-bin
cp /usr/local/src/cvsweb.cgi $TARGET/cgi-bin
chmod 755 $TARGET/cgi-bin/*

echo Copying other pre-packaged software to $TARGET/downloads
cp /usr/local/src/pilot-link.0.9.0.tar.gz $TARGET/downloads
cp /usr/local/src/JavaDeps.tar.gz $TARGET/downloads
cp /usr/local/src/dejagnu-1.3.tar.gz $TARGET/downloads
cp /usr/local/src/polardoc1.0.7.jar $TARGET/downloads
