from javax import swing

# This is an experimental Script to write Forms to code
# It currently only works for Border and Grid layouts
# It needs every Component to be given a non null name
# It does not Components into the right order for Grid layouts
# It does not handle Nested Containers
#
# To use, First run this Pyhthon file
# Then go to Python console
# Type 
# x=CodeWriter()
# x.writeFile()
# And then choose execute
# Then select the file name to save to




class CodeWriter:

	count=1
	variableNames={}
	variables=[]	# Contains Class/Variable name mappings


	def getResizeContainerVariableNames(self , rc):
		result = []
		comps = rc.getResizeComponents()
		
		for comp in comps:
			varName = self.getCompVarName(comp)
			className = self.getCompClassName(comp)
			t = varName , className
			result.append(t)

			if isinstance(comp , korfe.ResizeComponent):
				if isinstance(comp.getComponent() , korfe.ResizeContainer):
						result = result + self.getResizeContainerVariableNames(comp.getComponent())
			
		return result

	
	
	def writeHeader(self,f , name):
		f.write("/*\n")
		f.write(" * Written by Korfe\n")
		f.write(" * With assistance from JPython\n")
		f.write(" */\n")
		f.write("\n")
		f.write("\n")
		f.write("class " + name +" extends javax.swing.JPanel\n")
		f.write("{\n")
	

	#Write the setup method
	def writeSetupGUI(self,f):
		f.write("\n")
		f.write("	//Call this method to setup the GUI\n")
		f.write("	public void setupGUI()\n")
		f.write("	{\n")

		fc=util.ObjectMap.getObject("FormController")	#Get the FormController
	
		form = fc.getCurrentForm()
		if form == None:
			return
	
		rc = form.getResizeContainer()
		self.writeForResizeContainer(rc , None , f)
				
		f.write("	}\n")



	#Write out code for rc, using varName
	def writeForResizeContainer(self , rc , rcName , f):

		#Make the string to put at the start of adds and setLayouts
		if rcName==None:
			start=""
		else:
			start=rcName+"."
		

		#Create the code to setup the LayoutManager
		layout = rc.getLayoutController()

		layoutName = self.getLayoutName()

		setupLines = layout.getSetupLayoutCode(layoutName)
		for line in setupLines:
			f.write("		"+ line+ "\n")
		f.write("		" + start + "setLayout("+layoutName+");\n\n")



		#Get each component from the LayoutManager
		size = layout.getComponentCount()		
		for pos in range(size):

			#Get the details for the Component
			comp      = layout.getComponentNum(pos)
			details   = layout.getLayoutConstraint(pos)

			varName   = self.getCompVarName(comp)
			className = self.getCompClassName(comp)


			if (varName == None):
				varName=self.getVariableName(comp)

			t= varName , className
			self.variables.append(t)

			if (varName != None):

				#Create a new instance
				f.write("		"+ varName+" = new "+className+"();\n")

				if isinstance(comp , korfe.ResizeComponent):

					
					#Get the component inside the ResizeComponent wrapper
					insideComp=comp.getComponent()

					#Write the changed properties
					self.writeChangedProperties(comp , varName , f)

					#If we the Inside Component is a resizeContainer, then set it up
					if isinstance(insideComp , korfe.ResizeContainer):
						self.writeForResizeContainer(insideComp , varName , f)
				

				#Write the code to add the Component
				if (details != None):
					f.write("		" + start +  "add("+varName+" , "+details+");\n")
				else:
					f.write("		" + start +  "add("+varName+");\n")

				if layout.usesSpecialCode():
					extraCode   = layout.getSpecialAddCode(varName , pos)
					for line in extraCode:
						f.write("		" + line+"\n")

				f.write("\n")

	def writeChangedProperties( self ,comp , varName , f):
		changed=comp.getChangedProperties()
		for pd in changed:
			method = pd.getWriteMethod()
			mName = method.getName()

			r=korfe.Utils.getCodeTextForPropertyDescriptor(pd , comp.getComponent())
			f.write("		"+varName+"."+mName+"(" + r + ");\n")


	
	
	def writeVariables(self,f):
		f.write("\n")
		f.write("	//Variables\n")

		for x in self.variables:
			varName , className  = x

			if varName == None:
				varName="Null"

			if className == None:
				className="Unknown"

			f.write("	private " + className + " " + varName + ";\n")

	
	
	def writeTrailer(self,f):
		f.write("}\n")
	

	
	def writeFile(self):
		self.count=1
		self.variableNames={}
		self.variables=[]	# Contains Class/Variable name mappings


		fc=util.ObjectMap.getObject("FormController")	#Get the FormController	
		form = fc.getCurrentForm()
		if form == None:
			return

		name = self.getFileName()
		if name == None:
			return
	
		f=open(name,"wt")
	
		self.writeHeader(f,"Test")
		self.writeSetupGUI(f)
		self.writeVariables(f)
		self.writeTrailer(f)
		f.close()
	

	
	#Get the name to use
	def getFileName(self):
		frame = util.ObjectMap.getObject("KorfeFrame")
		filechooser = swing.JFileChooser()
		returnVal = filechooser.showSaveDialog(frame)
		if (returnVal == swing.JFileChooser.APPROVE_OPTION):
			file = filechooser.getSelectedFile()
			return file.getPath()
		else:
			return None



	#Get the Component Variable name used for o
	#This may later re-allocate names that are null?
	def getCompVarName(self , o):
		if isinstance(o , korfe.ResizeComponent):
			return o.getComponent().getName()
		else:
			return o.getName()


	#Get the Component Class name used for o
	def getCompClassName(self , o):
		if isinstance(o , korfe.ResizeComponent):
			inside = o.getComponent()

			if isinstance(inside , korfe.ResizeContainer):
				return inside.getContainer().getClass().__name__
			else:
				return inside.getClass().__name__
		else:
			return o.getClass().__name__


	#Gets the changed for for propertydescriptor pd, in object
	def getChangedValue(self , pd , object):
		method = pd.getReadMethod()
		result = method.invoke(object , [])
		return result;

	def getLayoutName(self):
		result = "layout"+ `self.count`
		self.count=self.count+1
		return result


	def getVariableName(self , Object):
		o=Object.__class__
		pos=0
		if self.variableNames.has_key(o):
			pos=self.variableNames[o]

		self.variableNames[o]=pos+1
		return "variable"+`pos`
